diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_tburst.c PleXusIRCd-1.17a/modules/m_tburst.c
--- ircd-hybrid-7.0/modules/m_tburst.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_tburst.c	Mon Jun 16 18:49:08 2003
@@ -0,0 +1,162 @@
+/*  contrib/m_tburst.c
+ *  Copyright (C) 2002 Hybrid Development Team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_tburst.c,v 1.12 2002/12/18 05:33:29 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"
+#include "ircd.h"
+#include "send.h"
+#include "msg.h"
+#include "modules.h"
+#include "hook.h"
+#include "hash.h"
+#include "s_serv.h"
+#include "s_conf.h"
+
+
+/* TBURST_PROPAGATE
+ *
+ * If this is defined, when we receive a TBURST thats successful
+ * (ie: our topic changes), the TBURST will be propagated to other
+ * servers that support TBURST
+ */
+#define TBURST_PROPAGATE
+
+
+
+static void ms_tburst(struct Client *, struct Client *, int, char **);
+static void set_topic(struct Client *, struct Channel *, 
+		      time_t, char *, char *);
+static void set_tburst_capab();
+static void unset_tburst_capab();
+int send_tburst(struct hook_burst_channel *);
+
+struct Message tburst_msgtab = {
+  "TBURST", 0, 0, 6, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_tburst, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&tburst_msgtab);
+  hook_add_hook("burst_channel", (hookfn *)send_tburst);
+  set_tburst_capab();
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&tburst_msgtab);
+  hook_del_hook("burst_channel", (hookfn *)send_tburst);
+  unset_tburst_capab();
+}
+
+const char *_version = "$Revision: 1.12 $";
+#endif
+
+/* ms_tburst()
+ * 
+ *      parv[0] = sender prefix
+ *      parv[1] = channel timestamp
+ *      parv[2] = channel
+ *      parv[3] = topic timestamp
+ *      parv[4] = topic setter
+ *      parv[5] = topic
+ */
+static void ms_tburst(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct Channel *chptr;
+  time_t newchannelts;
+  time_t newtopicts;
+
+  newchannelts = atol(parv[1]);
+  newtopicts = atol(parv[3]);
+
+  if((chptr = hash_find_channel(parv[2])))
+  {
+    if(chptr->channelts < newchannelts)
+      return;
+
+    else if(chptr->channelts == newchannelts)
+    {
+      if(chptr->topic == NULL || (chptr->topic_time > newtopicts))
+	set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+      else
+	return;
+    }
+
+    else
+      set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+  }
+}
+
+static void set_topic(struct Client *source_p, struct Channel *chptr, 
+		      time_t newtopicts, char *topicwho, char *topic)
+{
+  set_channel_topic(chptr, topic, topicwho, newtopicts);
+
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s TOPIC %s :%s",
+		       ConfigServerHide.hide_servers ? me.name : me.name,
+		       chptr->chname, chptr->topic == NULL ? "" : chptr->topic);
+
+#ifdef TBURST_PROPAGATE
+  sendto_server(source_p, NULL, chptr, CAP_TBURST, NOCAPS, NOFLAGS,
+		":%s TBURST %ld %s %ld %s :%s",
+		me.name, chptr->channelts, chptr->chname,
+		chptr->topic_time, 
+                chptr->topic_info == NULL ? "" : chptr->topic_info,
+                chptr->topic == NULL ? "" : chptr->topic);
+#endif
+}
+
+static void set_tburst_capab()
+{
+  default_server_capabs |= CAP_TBURST;
+}
+
+static void unset_tburst_capab()
+{
+  default_server_capabs &= ~CAP_TBURST;
+}
+
+int send_tburst(struct hook_burst_channel *data)
+{
+  if(data->chptr->topic != NULL && IsCapable(data->client, CAP_TBURST))
+    sendto_one(data->client, ":%s TBURST %ld %s %ld %s :%s",
+               me.name, data->chptr->channelts, data->chptr->chname,
+	       data->chptr->topic_time, data->chptr->topic_info, 
+	       data->chptr->topic);
+
+  return 0;
+}
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_topic.c PleXusIRCd-1.17a/modules/m_topic.c
--- ircd-hybrid-7.0/modules/m_topic.c	Mon Jun 10 21:39:38 2002
+++ PleXusIRCd-1.17a/modules/m_topic.c	Mon Jun 16 18:12:18 2003
@@ -138,7 +138,7 @@
 	    {
 	      char topic_info[USERHOST_REPLYLEN]; 
               ircsprintf(topic_info, "%s!%s@%s",
-			 source_p->name, source_p->username, source_p->host);
+			 source_p->name, source_p->username, source_p->vhost);
               set_channel_topic(chptr, parv[2], topic_info, CurrentTime);
 	      
 	      sendto_server(client_p, NULL, chptr, NOCAPS, NOCAPS, NOFLAGS,
@@ -151,7 +151,7 @@
 				       chptr, ":%s!%s@%s TOPIC %s :%s",
 				       source_p->name,
 				       source_p->username,
-				       source_p->host,
+				       source_p->vhost,
 				       root_chan->chname,
 				       chptr->topic == NULL ? "" : chptr->topic);
 
@@ -167,7 +167,7 @@
 				       chptr, ":%s!%s@%s TOPIC %s :%s",
 				       source_p->name,
 				       source_p->username,
-				       source_p->host,
+				       source_p->vhost,
 				       root_chan->chname, chptr->topic == NULL ? "" : chptr->topic);
 		}
 	    }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_trace.c PleXusIRCd-1.17a/modules/m_trace.c
--- ircd-hybrid-7.0/modules/m_trace.c	Wed Sep  4 21:10:24 2002
+++ PleXusIRCd-1.17a/modules/m_trace.c	Wed Jul  9 00:47:28 2003
@@ -161,7 +161,7 @@
       
       if(target_p && IsPerson(target_p)) 
       {
-        name = get_client_name(target_p, HIDE_IP);
+        name = get_client_name(target_p, MASK_IP);
         inetntop(target_p->localClient->aftype, &IN_ADDR(target_p->localClient->ip), ipaddr, HOSTIPLEN);
 
         class_name = get_client_class(target_p);
@@ -170,8 +170,7 @@
         {
           sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], class_name, name, 
-                     MyOper(source_p) ? ipaddr :
-		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+                     target_p->vhost,
                      CurrentTime - target_p->lasttime,
                      (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
         }
@@ -377,8 +376,7 @@
 #ifdef HIDE_SPOOF_IPS
 		       IsIPSpoof(target_p) ? "255.255.255.255" : ip,
 #else
-                       MyOper(source_p) ? ip :
-		       (IsIPSpoof(target_p) ? "255.255.255.255" : ip),
+                       target_p->vhost,
 #endif
 		       CurrentTime - target_p->lasttime,
 		       (target_p->user)?(CurrentTime - target_p->user->last):0);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_unkline.c PleXusIRCd-1.17a/modules/m_unkline.c
--- ircd-hybrid-7.0/modules/m_unkline.c	Mon Nov 18 14:54:58 2002
+++ PleXusIRCd-1.17a/modules/m_unkline.c	Mon Dec  1 06:21:40 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_unkline.c,v 1.51 2002/11/18 19:54:58 db Exp $
+ *  $Id: m_unkline.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -37,6 +37,7 @@
 #include "s_conf.h"
 #include "s_log.h"
 #include "s_misc.h"
+#include "s_serv.h"
 #include "send.h"
 #include "msg.h"
 #include "s_gline.h"
@@ -50,7 +51,7 @@
 
 struct Message msgtabs[] = {
   {"UNKLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
-   {m_unregistered, m_not_oper, m_error, mo_unkline}},
+   {m_unregistered, m_not_oper, mo_unkline, mo_unkline}},
   {"UNDLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_undline}}, 
   {"UNGLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
@@ -73,11 +74,10 @@
   mod_del_cmd(&msgtabs[1]);
   mod_del_cmd(&msgtabs[2]);
 }
-const char *_version = "$Revision: 1.51 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
-static int flush_write(struct Client *, FBFILE *in, FBFILE *out,
-		       char *, char *);
+static int flush_write(struct Client *, FBFILE* , char *, char *);
 static int remove_tkline_match(char *,char *);
 
 
@@ -88,21 +88,22 @@
 **
 **      parv[0] = sender
 **      parv[1] = address to remove
-*
-*
+*		parv[2] = "ON"
+*		parv[3] = remote server
 */
-static void
-mo_unkline (struct Client *client_p,struct Client *source_p,
-	    int parc,char *parv[])
+static void mo_unkline (struct Client *client_p,struct Client *source_p,
+                       int parc,char *parv[])
 {
   FBFILE *in, *out;
-  int pairme=0;
+  int pairme=0,error_on_write = NO;
   char buf[BUFSIZE], buff[BUFSIZE], temppath[BUFSIZE], *user, *host, *p;
   const char  *filename;                /* filename to use for unkline */
   mode_t oldumask;
 
   ircsprintf(temppath, "%s.tmp", ConfigFileEntry.klinefile);
   
+  if (MyClient(source_p)) 
+  {
   if (!IsOperUnkline(source_p))
     {
       sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",me.name,parv[0]);
@@ -114,6 +115,7 @@
                  me.name, source_p->name, "UNKLINE");
       return;
     }
+  }
 
   if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
     {
@@ -136,6 +138,26 @@
                  me.name, source_p->name);
       return;
     }
+    
+  if ((parc > 3) && !irccmp(parv[2], "ON")) 
+  {
+	sendto_server(NULL, source_p, NULL, CAP_KLN, NOCAPS, LL_ICLIENT,
+                    ":%s UNKLINE %s@%s ON %s",
+                    source_p->name, 
+                    user, host, 
+                    parv[3]);
+
+      /* If we are sending it somewhere that doesnt include us, we stop
+       * else we apply it locally too
+       */
+	if (!match(parv[3], me.name))
+		return;
+
+	if (!MyClient(source_p))
+	if (!find_u_conf((char *)source_p->user->server, 
+		source_p->username, source_p->host))
+		return;
+  }
 
   if (remove_tkline_match(host, user))
     {
@@ -180,21 +202,22 @@
 
       if ((*buff == '\0') || (*buff == '#'))
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
+	  continue;
 	}
       
       if ((found_user = getfield(buff)) == NULL)
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
 	  continue;
 	}
 
       if ((found_host = getfield(NULL)) == NULL)
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
 	  continue;
 	}
 
@@ -204,8 +227,8 @@
 	}
       else
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
 	}
     }
   fbclose(in);
@@ -215,9 +238,18 @@
 /* If there was an error on a write above, then its been reported
  * and I am not going to trash the original kline /conf file
  */
-
-  (void)rename(temppath, filename);
-  rehash(0);
+  if(!error_on_write)
+    {
+      (void)rename(temppath, filename);
+      rehash(0);
+    }
+  else
+    {
+      sendto_one(source_p,
+		 ":%s NOTICE %s :Couldn't write temp kline file, aborted",
+		 me.name,source_p->name);
+      return;
+    }
 
   if(!pairme)
     {
@@ -241,13 +273,12 @@
  * flush_write()
  *
  * inputs       - pointer to client structure of oper requesting unkline
- *		- in is the input file descriptor
- *              - out is the output file descriptor
+ *              - out is the file descriptor
  *              - buf is the buffer to write
  *              - ntowrite is the expected number of character to be written
  *              - temppath is the temporary file name to be written
- * output       - -1 for error on write
- *              - 0 for ok
+ * output       - YES for error on write
+ *              - NO for success
  * side effects - if successful, the buf is written to output file
  *                if a write failure happesn, and the file pointed to
  *                by temppath, if its non NULL, is removed.
@@ -258,17 +289,15 @@
  * -Dianora
  */
 
-static int
-flush_write(struct Client *source_p, FBFILE *in, FBFILE* out, 
-	    char *buf, char *temppath)
+static int flush_write(struct Client *source_p, FBFILE* out, char *buf,
+		       char *temppath)
 {
-  int error_on_write = (fbputs(buf, out) < 0) ? (-1) : (0);
+  int error_on_write = (fbputs(buf, out) < 0) ? YES : NO;
 
   if (error_on_write)
     {
-      sendto_one(source_p,":%s NOTICE %s :Unable to write to %s aborting",
+      sendto_one(source_p,":%s NOTICE %s :Unable to write to %s",
         me.name, source_p->name, temppath );
-      fbclose(in);
       fbclose(out);
       if(temppath != (char *)NULL)
         (void)unlink(temppath);
@@ -329,7 +358,7 @@
   FBFILE* out;
   char  buf[BUFSIZE], buff[BUFSIZE], temppath[BUFSIZE], *p;
   const char  *filename,*cidr, *found_cidr;
-  int pairme = NO;
+  int pairme = NO, error_on_write = NO;
   mode_t oldumask;
 
   ircsprintf(temppath, "%s.tmp", ConfigFileEntry.dlinefile);
@@ -362,7 +391,7 @@
     }
 
   oldumask = umask(0);                  /* ircd is normally too paranoid */
-  if ((out = fbopen(temppath, "w")) == NULL)
+  if ( (out = fbopen(temppath, "w")) == 0)
     {
       sendto_one(source_p, ":%s NOTICE %s :Cannot open %s",
 		 me.name,parv[0],temppath);
@@ -381,15 +410,15 @@
 
       if ((*buff == '\0') || (*buff == '#'))
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
-  	   continue;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
+	  continue;
 	}
 
       if ((found_cidr = getfield(buff)) == NULL)
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
 	  continue;
 	}
       
@@ -399,16 +428,29 @@
 	}
       else
 	{
-	  if(flush_write(source_p, in, out, buf, temppath) < 0)
-	    return;
+	  if(!error_on_write)
+	    flush_write(source_p, out, buf, temppath);
+	  continue;
 	}
+
     }
 
   fbclose(in);
   fbclose(out);
 
-  (void)rename(temppath, filename);
-  rehash(0);
+  if (!error_on_write)
+    {
+
+      (void)rename(temppath, filename);
+      rehash(0);
+    }
+  else
+    {
+      sendto_one(source_p,
+		 ":%s NOTICE %s :Couldn't write D-line file, aborted",
+		 me.name, parv[0]);
+      return;
+    }
 
   if (!pairme)
     {
@@ -434,9 +476,8 @@
 **      parv[1] = gline to remove
 */
 
-static void
-mo_ungline(struct Client *client_p, struct Client *source_p,
-	   int parc,char *parv[])
+static void mo_ungline(struct Client *client_p, struct Client *source_p,
+                      int parc,char *parv[])
 {
   char  *user,*host;
 
@@ -453,11 +494,11 @@
       return;
     }
 
-  if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
+  if ( (host = strchr(parv[1], '@')) || *parv[1] == '*' )
     {
       /* Explicit user@host mask given */
 
-      if(host != NULL)                  /* Found user@host */
+      if(host)                  /* Found user@host */
         {
           user = parv[1];       /* here is user part */
           *(host++) = '\0';     /* and now here is host */
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_unkline.c-backup PleXusIRCd-1.17a/modules/m_unkline.c-backup
--- ircd-hybrid-7.0/modules/m_unkline.c-backup	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_unkline.c-backup	Sun Nov 30 07:59:33 2003
@@ -0,0 +1,497 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_unkline.c: Unklines a user.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_unkline.c,v 1.51 2002/11/18 19:54:58 db Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "client.h"
+#include "common.h"
+#include "fileio.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "list.h"
+#include "hostmask.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "msg.h"
+#include "s_gline.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void mo_unkline(struct Client*, struct Client*, int, char**);
+static void mo_undline(struct Client*, struct Client*, int, char**);
+static void mo_ungline(struct Client*, struct Client*, int, char**);
+
+struct Message msgtabs[] = {
+  {"UNKLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
+   {m_unregistered, m_not_oper, m_error, mo_unkline}},
+  {"UNDLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
+   {m_unregistered, m_not_oper, m_error, mo_undline}}, 
+  {"UNGLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
+   {m_unregistered, m_not_oper, mo_ungline, mo_ungline}}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&msgtabs[0]);
+  mod_add_cmd(&msgtabs[1]);
+  mod_add_cmd(&msgtabs[2]);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&msgtabs[0]);
+  mod_del_cmd(&msgtabs[1]);
+  mod_del_cmd(&msgtabs[2]);
+}
+const char *_version = "$Revision: 1.51 $";
+#endif
+
+static int flush_write(struct Client *, FBFILE *in, FBFILE *out,
+		       char *, char *);
+static int remove_tkline_match(char *,char *);
+
+
+/*
+** mo_unkline
+** Added Aug 31, 1997 
+** common (Keith Fralick) fralick@gate.net
+**
+**      parv[0] = sender
+**      parv[1] = address to remove
+*
+*
+*/
+static void
+mo_unkline (struct Client *client_p,struct Client *source_p,
+	    int parc,char *parv[])
+{
+  FBFILE *in, *out;
+  int pairme=0;
+  char buf[BUFSIZE], buff[BUFSIZE], temppath[BUFSIZE], *user, *host, *p;
+  const char  *filename;                /* filename to use for unkline */
+  mode_t oldumask;
+
+  ircsprintf(temppath, "%s.tmp", ConfigFileEntry.klinefile);
+  
+  if (strcmp("OperServ",source_p->name) && !IsOperUnkline(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",me.name,parv[0]);
+      return;
+    }
+  if (parc < 2)
+    {
+      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, source_p->name, "UNKLINE");
+      return;
+    }
+
+  if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
+    {
+      /* Explicit user@host mask given */
+
+      if(host)                  /* Found user@host */
+        {
+          user = parv[1];       /* here is user part */
+          *(host++) = '\0';     /* and now here is host */
+        }
+      else
+        {
+          user = "*";           /* no @ found, assume its *@somehost */
+          host = parv[1];
+        }
+    }
+  else
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Invalid parameters",
+                 me.name, source_p->name);
+      return;
+    }
+
+  if (remove_tkline_match(host, user))
+    {
+      sendto_one(source_p,
+		 ":%s NOTICE %s :Un-klined [%s@%s] from temporary k-lines",
+		 me.name, parv[0],user, host);
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+			   "%s has removed the temporary K-Line for: [%s@%s]",
+			   get_oper_name(source_p), user, host);
+      ilog(L_NOTICE, "%s removed temporary K-Line for [%s@%s]", parv[0], user,
+	   host);
+      return;
+    }
+
+  filename = get_conf_name(KLINE_TYPE);
+  if ((in = fbopen(filename, "r")) == 0)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Cannot open %s", me.name, parv[0],
+		 filename);
+      return;
+    }
+
+  oldumask = umask(0);
+  if ((out = fbopen(temppath, "w")) == 0)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Cannot open %s", me.name, parv[0],
+		 temppath);
+      fbclose(in);
+      umask(oldumask);
+      return;
+    }
+  umask(oldumask);
+
+  while (fbgets(buf, sizeof(buf), in)) 
+    {
+      char *found_host, *found_user;
+
+      strlcpy(buff, buf, BUFSIZE);
+
+      if ((p = strchr(buff,'\n')) != NULL)
+	*p = '\0';
+
+      if ((*buff == '\0') || (*buff == '#'))
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	}
+      
+      if ((found_user = getfield(buff)) == NULL)
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	  continue;
+	}
+
+      if ((found_host = getfield(NULL)) == NULL)
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	  continue;
+	}
+
+      if ((irccmp(host,found_host) == 0) && (irccmp(user,found_user) == 0))
+	{
+	  pairme++;
+	}
+      else
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	}
+    }
+  fbclose(in);
+  fbclose(out);
+
+/* The result of the rename should be checked too... oh well */
+/* If there was an error on a write above, then its been reported
+ * and I am not going to trash the original kline /conf file
+ */
+
+  (void)rename(temppath, filename);
+  rehash(0);
+
+  if(!pairme)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :No K-Line for %s@%s",
+                 me.name, source_p->name,user,host);
+      return;
+    }
+
+  sendto_one(source_p, ":%s NOTICE %s :K-Line for [%s@%s] is removed", 
+             me.name, source_p->name, user,host);
+  sendto_realops_flags(FLAGS_ALL, L_ALL,
+		       "%s has removed the K-Line for: [%s@%s]",
+		       get_oper_name(source_p), user, host);
+
+  ilog(L_NOTICE, "%s removed K-Line for [%s@%s]",
+       source_p->name, user, host);
+  return; 
+}
+
+/*
+ * flush_write()
+ *
+ * inputs       - pointer to client structure of oper requesting unkline
+ *		- in is the input file descriptor
+ *              - out is the output file descriptor
+ *              - buf is the buffer to write
+ *              - ntowrite is the expected number of character to be written
+ *              - temppath is the temporary file name to be written
+ * output       - -1 for error on write
+ *              - 0 for ok
+ * side effects - if successful, the buf is written to output file
+ *                if a write failure happesn, and the file pointed to
+ *                by temppath, if its non NULL, is removed.
+ *
+ * The idea here is, to be as robust as possible when writing to the 
+ * kline file.
+ *
+ * -Dianora
+ */
+
+static int
+flush_write(struct Client *source_p, FBFILE *in, FBFILE* out, 
+	    char *buf, char *temppath)
+{
+  int error_on_write = (fbputs(buf, out) < 0) ? (-1) : (0);
+
+  if (error_on_write)
+    {
+      sendto_one(source_p,":%s NOTICE %s :Unable to write to %s aborting",
+        me.name, source_p->name, temppath );
+      fbclose(in);
+      fbclose(out);
+      if(temppath != (char *)NULL)
+        (void)unlink(temppath);
+    }
+  return(error_on_write);
+}
+
+/* static int remove_tkline_match(char *host, char *user)
+ * Input: A hostname, a username to unkline.
+ * Output: returns YES on success, NO if no tkline removed.
+ * Side effects: Any matching tklines are removed.
+ */
+static int
+remove_tkline_match(char *host, char *user)
+{
+  struct ConfItem *tk_c;
+  dlink_node *tk_n;
+  struct irc_inaddr addr, caddr;
+  int nm_t, cnm_t, bits, cbits;
+  nm_t = parse_netmask(host, &addr, &bits);
+
+  for (tk_n=temporary_klines.head; tk_n; tk_n=tk_n->next)
+    {
+      tk_c = (struct ConfItem*)tk_n->data;
+      cnm_t = parse_netmask(tk_c->host, &caddr, &cbits);
+      if (cnm_t != nm_t || irccmp(user, tk_c->user))
+	continue;
+      if ((nm_t==HM_HOST && !irccmp(tk_c->host, host)) ||
+	  (nm_t==HM_IPV4 && bits==cbits && match_ipv4(&addr, &caddr, bits))
+#ifdef IPV6
+	  || (nm_t==HM_IPV6 && bits==cbits && match_ipv6(&addr, &caddr, bits))
+#endif
+	  )
+	{
+	  dlinkDelete(tk_n, &temporary_klines);
+	  free_dlink_node(tk_n);
+	  delete_one_address_conf(tk_c->host, tk_c);
+	  return YES;
+	}
+    }
+  return NO;
+}
+
+/*
+** m_undline
+** added May 28th 2000 by Toby Verrall <toot@melnet.co.uk>
+** based totally on m_unkline
+** added to hybrid-7 7/11/2000 --is
+**
+**      parv[0] = sender nick
+**      parv[1] = dline to remove
+*/
+static void
+mo_undline (struct Client *client_p, struct Client *source_p,
+            int parc,char *parv[])
+{
+  FBFILE* in;
+  FBFILE* out;
+  char  buf[BUFSIZE], buff[BUFSIZE], temppath[BUFSIZE], *p;
+  const char  *filename,*cidr, *found_cidr;
+  int pairme = NO;
+  mode_t oldumask;
+
+  ircsprintf(temppath, "%s.tmp", ConfigFileEntry.dlinefile);
+
+  if (!IsOperUnkline(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",me.name,
+		 parv[0]);
+      return;
+    }
+
+  cidr = parv[1];
+
+#if 0
+  if ((type=parse_netmask(cidr,&ip_host,&ip_mask)) == HM_HOST)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Invalid parameters",
+		 me.name, parv[0]);
+      return;
+    }
+#endif
+
+  filename = get_conf_name(DLINE_TYPE);
+
+  if ((in = fbopen(filename, "r")) == 0)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Cannot open %s",
+		 me.name,parv[0],filename);
+      return;
+    }
+
+  oldumask = umask(0);                  /* ircd is normally too paranoid */
+  if ((out = fbopen(temppath, "w")) == NULL)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Cannot open %s",
+		 me.name,parv[0],temppath);
+      fbclose(in);
+      umask(oldumask);                  /* Restore the old umask */
+      return;
+    }
+  umask(oldumask);                    /* Restore the old umask */
+
+  while(fbgets(buf, sizeof(buf), in))
+    {
+      strlcpy(buff, buf, BUFSIZE);
+
+      if ((p = strchr(buff,'\n')) != NULL)
+	*p = '\0';
+
+      if ((*buff == '\0') || (*buff == '#'))
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+  	   continue;
+	}
+
+      if ((found_cidr = getfield(buff)) == NULL)
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	  continue;
+	}
+      
+      if (irccmp(found_cidr,cidr) == 0)
+	{
+	  pairme++;
+	}
+      else
+	{
+	  if(flush_write(source_p, in, out, buf, temppath) < 0)
+	    return;
+	}
+    }
+
+  fbclose(in);
+  fbclose(out);
+
+  (void)rename(temppath, filename);
+  rehash(0);
+
+  if (!pairme)
+    {
+      sendto_one(source_p, ":%s NOTICE %s :No D-Line for %s", me.name,
+		 parv[0],cidr);
+      return;
+    }
+
+  sendto_one(source_p, ":%s NOTICE %s :D-Line for [%s] is removed",
+	     me.name, parv[0], cidr);
+  sendto_realops_flags(FLAGS_ALL, L_ALL, "%s has removed the D-Line for: [%s]",
+		       get_oper_name(source_p), cidr);
+  ilog(L_NOTICE, "%s removed D-Line for [%s]", get_oper_name(source_p),
+       cidr);
+}
+
+/*
+** m_ungline
+** added May 29th 2000 by Toby Verrall <toot@melnet.co.uk>
+** added to hybrid-7 7/11/2000 --is
+**
+**      parv[0] = sender nick
+**      parv[1] = gline to remove
+*/
+
+static void
+mo_ungline(struct Client *client_p, struct Client *source_p,
+	   int parc,char *parv[])
+{
+  char  *user,*host;
+
+  if (!ConfigFileEntry.glines)
+    {
+      sendto_one(source_p,":%s NOTICE %s :UNGLINE disabled",me.name,parv[0]);
+      return;
+    }
+
+  if (!IsOperUnkline(source_p) || !IsOperGline(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",
+                 me.name,parv[0]);
+      return;
+    }
+
+  if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
+    {
+      /* Explicit user@host mask given */
+
+      if(host != NULL)                  /* Found user@host */
+        {
+          user = parv[1];       /* here is user part */
+          *(host++) = '\0';     /* and now here is host */
+        }
+      else
+        {
+          user = "*";           /* no @ found, assume its *@somehost */
+          host = parv[1];
+        }
+    }
+  else
+    {
+      sendto_one(source_p, ":%s NOTICE %s :Invalid parameters",
+                 me.name, parv[0]);
+      return;
+    }
+
+  if(remove_gline_match(user, host))
+    {
+      sendto_one(source_p, ":%s NOTICE %s :G-Line for [%s@%s] is removed",
+                 me.name, parv[0], user, host);
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+			   "%s has removed the G-Line for: [%s@%s]",
+			   get_oper_name(source_p), user, host );
+      ilog(L_NOTICE, "%s removed G-Line for [%s@%s]",
+          get_oper_name(source_p), user, host);
+      return;
+    }
+  else
+    {
+      sendto_one(source_p, ":%s NOTICE %s :No G-Line for %s@%s",
+                 me.name, parv[0],user,host);
+      return;
+    }
+}
+
+
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_userhost.c PleXusIRCd-1.17a/modules/m_userhost.c
--- ircd-hybrid-7.0/modules/m_userhost.c	Fri May 24 19:34:23 2002
+++ PleXusIRCd-1.17a/modules/m_userhost.c	Mon Jun 16 18:08:46 2003
@@ -115,7 +115,7 @@
 			    IsOper(target_p) ? "*" : "",
 			    (target_p->user->away) ? '-' : '+',
 			    target_p->username,
-			    target_p->host);
+			    target_p->vhost);
 	  }
 
 	  if((rl + cur_len) < (BUFSIZE-10))
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_who.c PleXusIRCd-1.17a/modules/m_who.c
--- ircd-hybrid-7.0/modules/m_who.c	Thu Jan 16 18:54:02 2003
+++ PleXusIRCd-1.17a/modules/m_who.c	Mon Jun 16 18:05:38 2003
@@ -313,7 +313,7 @@
 
     if ((mask == NULL) ||
 	match(mask, target_p->name) || match(mask, target_p->username) ||
-	match(mask, target_p->host) || 
+	match(mask, target_p->host) || match(mask, target_p->vhost) ||
 	(match(mask, target_p->user->server) && 
 	 (IsOper(source_p) || !ConfigServerHide.hide_servers)) ||
 	match(mask, target_p->info))
@@ -383,7 +383,7 @@
     if (!mask ||
         match(mask, target_p->name) || match(mask, target_p->username) ||
 	match(mask, target_p->host) || match(mask, target_p->user->server) ||
-	match(mask, target_p->info))
+	match(mask, target_p->info) || match(mask, target_p->vhost))
     {
 		
       do_who(source_p, target_p, NULL, "");
@@ -572,7 +572,7 @@
     sendto_one(source_p, form_str(RPL_WHOREPLY), me.name, source_p->name,
 	       (chname) ? (chname) : "*",
 	       target_p->username,
-	       target_p->host, IsOper(source_p) ? target_p->user->server : "*",
+	       target_p->vhost, IsOper(source_p) ? target_p->user->server : "*",
 	       target_p->name,
 	       status, 0, target_p->info);
   }
@@ -581,7 +581,7 @@
     sendto_one(source_p, form_str(RPL_WHOREPLY), me.name, source_p->name,
 	       (chname) ? (chname) : "*",
 	       target_p->username,
-	       target_p->host,  target_p->user->server, target_p->name,
+	       target_p->vhost,  target_p->user->server, target_p->name,
 	       status, target_p->hopcount, target_p->info);
   }
 }
